/*
 * TrisGameGUIApp.java
 */

package trisgamegui;
import trisgame.model.*;

import org.jdesktop.application.Application;
import org.jdesktop.application.SingleFrameApplication;

/**
 * The main class of the application.
 */
public class TrisGameGUIApp extends SingleFrameApplication {
    private TrisGameGUIView vista;
    private Tris tavolo;
    private Partita gioco;
    /**
     * At startup create and show the main frame of the application.
     */
    @Override protected void startup() {
        vista = new TrisGameGUIView(this);
        show(vista);
        //istanza deglio oggetti per la partita
        tavolo=new Tris();
        gioco=new Partita();
        gioco.setGo(new Giocatore('o',"Mario"));
        gioco.setGx(new Giocatore('x',"Antonio"));
        gioco.setProssimoTurno();

        vista.mostraTris(tavolo);
        vista.mostraNomeTurno(gioco.getTurno().getNome());
    }

    /**
     * This method is to initialize the specified window by injecting resources.
     * Windows shown in our application come fully initialized from the GUI
     * builder, so this additional configuration is not needed.
     */
    @Override protected void configureWindow(java.awt.Window root) {
    }

    /**
     * A convenient static getter for the application instance.
     * @return the instance of TrisGameGUIApp
     */
    public static TrisGameGUIApp getApplication() {
        return Application.getInstance(TrisGameGUIApp.class);
    }

    /**
     * Main method launching the application.
     */
    public static void main(String[] args) {
        launch(TrisGameGUIApp.class, args);
    }

    public void clickSuCasella(Coordinate coord){
        boolean vincente = tavolo.mossa(gioco.getTurno().getCar(),coord.getR(),coord.getC());
        vista.mostraTris(tavolo);
        if (vincente){
            vista.mostraVittoria(gioco.getTurno().getNome());
        }
        else {
          gioco.setProssimoTurno();
          vista.mostraNomeTurno(gioco.getTurno().getNome());
        }
    }
}
